module Watchcow
  module ApiSymbol
    class << self
      def contract_list
        %w{btc eth link dot eos trx ada ltc bch xrp bsv etc fil}
      end

      def dm_types
        data = mapping.select do |k, v|
          v.in? current_types
        end.keys
      end

      def current_types
        Watchcow::ContractInfo.current_contracts
      end

      def mapping
        {
          'cq' => 'quarter',
          'nq' => 'next_quarter',
          'nw' => 'next_week',
          'cw' => 'this_week'
        }
      end
    end
  end
end