module Watchcow
  class MarketDepth

    URLDM = "https://api.hbdm.com/market/depth"
    URLPRO = "https://api.huobi.pro/market/depth"

    class << self
      # Spot market or Futures market all goes here
      def call(params:, k:)
        url = target_url(params, k)
        HTTParty.get(url)
      end

      def prepared_params(params, k)
        return '' if params.nil?
        step =
          if k == :future
            "&type=step6"
          else
            "&type=step2"
          end
        arr = []
        params.each_pair do |k,v|
          arr.push "#{k}=#{v}"
        end
        return "#{arr.join('&')}#{step}"
      end

      def target_url(params, k)
        prefix = k == :future ? URLDM : URLPRO
        "#{prefix}?#{prepared_params(params, k)}"
      end
    end
  end
end